/*
 * Copyright (C) 2009 SENJU, Jiro
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/* for some old systems */
#define _REENTRANT
#define POSIX_C_SOURCE 199506L
#include <pthread.h>

#include <assert.h>
#include <err.h>
#include <stdio.h>
#include <unistd.h>

#include "lib.h"

void *func(void *arg)
{
	int err, sock;
	ssize_t ssz;
	char a[BUFSIZ], *p;

	sock = (int)arg;
	ssz = read(sock, a, sizeof(a));
	assert(ssz > 0);
	assert(ssz != sizeof(a));

	p = get_path(a);
	if (p)
		do_sendfile(sock, p, /*delay*/0);
	err = close(sock);
	assert(!err);

	return NULL;
}

int main(int argc, char *argv[])
{
	int err, lsock, sock, port;
	struct sockaddr_in addr;
	pthread_t th;
	pthread_attr_t attr;

	/* port = 80; */
	port = IPPORT_USERRESERVED;
	warnx("listening on port %d", port);
	lsock = simple_server_socket(port, 64, /*non-blocking*/0);
	assert(lsock >= 0);

	err = pthread_attr_init(&attr);
	assert(!err);

	err = pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	assert(!err);

	while (1) {
		pthread_attr_t w;
		socklen_t l = sizeof(addr);

		sock = accept(lsock, (struct sockaddr *)&addr, &l);
		assert(sock >= 0);

		w = attr;
		err = pthread_create(&th, &w, func, (void *)sock);
		assert(!err);
	}

	return 0;
}
